/* MAXSIZE_k = max size of table for k-byte tokens */
#define MAXSIZE_1 (0xfful)
#define MAXSIZE_2 (0xff00ul)
#define MAXSIZE_3 (0xff0000ul)
#define MAXSIZE_4 (0xff000000ul)

#define BITS_PER_BYTE (8)
#define BYTE_MASK ((1 << BITS_PER_BYTE) - 1)

/* return the i-th least significant byte of x */
#define GET_BYTE(x, i) (((x) >> ((i) * BITS_PER_BYTE)) & BYTE_MASK)

/* delimiters for raw strings */
#define RAW_STRING_START (0xff)
#define RAW_STRING_END   (0x00)
