/* read a line of text from stdin up to delimiter
 * and return it (without terminating delimiter) as a freshly-malloc'd block.
 * Caller is responsible for freeing this block.
 * Returns 0 on error or EOF at start of line.
 * If EOF occurs in the middle of a line, returns line as if it were
 * properly terminated.
 */
char *getline(int delimiter);
